"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactPaginate = _interopRequireDefault(require("react-paginate"));

var _reactRichUiButton = _interopRequireDefault(require("../button/react-rich-ui-button"));

require("./style.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// dynamically loading Axios
var axios;

try {
  axios = require('axios');
} catch (e) {
  console.log('Axios is not installed. Falling back to fetch');
}
/**
 * @author coder966
 */


var RruPageableTable = function RruPageableTable(_ref) {
  var id = _ref.id,
      endpoint = _ref.endpoint,
      columns = _ref.columns,
      actions = _ref.actions,
      actionsLabel = _ref.actionsLabel,
      search = _ref.search,
      pageSize = _ref.pageSize,
      previousLabel = _ref.previousLabel,
      nextLabel = _ref.nextLabel,
      noDataLabel = _ref.noDataLabel,
      disableSorting = _ref.disableSorting,
      userPrivileges = _ref.userPrivileges,
      onResponse = _ref.onResponse;

  var getInitialState = function getInitialState() {
    return JSON.parse(sessionStorage.getItem('RruPageableTable_' + id)) || {
      currentPage: 0,
      sortBy: 'id',
      sortDir: 'desc'
    };
  };

  var persistState = function persistState(state) {
    return sessionStorage.setItem('RruPageableTable_' + id, JSON.stringify(state));
  }; // fetched


  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      totalPages = _useState2[0],
      setTotalPages = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = _slicedToArray(_useState3, 2),
      data = _useState4[0],
      setData = _useState4[1];

  var _useState5 = (0, _react.useState)(getInitialState().currentPage),
      _useState6 = _slicedToArray(_useState5, 2),
      currentPage = _useState6[0],
      setCurrentPage = _useState6[1]; // flags


  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      isLoading = _useState8[0],
      setIsLoading = _useState8[1];

  var _useState9 = (0, _react.useState)(null),
      _useState10 = _slicedToArray(_useState9, 2),
      error = _useState10[0],
      setError = _useState10[1]; // sort


  var _useState11 = (0, _react.useState)(getInitialState().sortBy),
      _useState12 = _slicedToArray(_useState11, 2),
      sortBy = _useState12[0],
      setSortBy = _useState12[1];

  var _useState13 = (0, _react.useState)(getInitialState().sortDir),
      _useState14 = _slicedToArray(_useState13, 2),
      sortDir = _useState14[0],
      setSortDir = _useState14[1]; // defaults


  var mPageSize = pageSize ? pageSize : 10;
  var mSort = sortBy ? sortBy + ',' + (sortDir ? sortDir : '') : '';
  (0, _react.useEffect)(function () {
    persistState({
      currentPage: currentPage,
      sortBy: sortBy,
      sortDir: sortDir
    });
  }, [currentPage, sortBy, sortDir]); // reload list when search, page, sort changes

  (0, _react.useEffect)(function () {
    setIsLoading(true);

    var params = _objectSpread({
      page: currentPage,
      size: mPageSize,
      sort: mSort
    }, search); // create an abstract promise for different HTTP client libs


    var dataPromise = new Promise(function (resolve, reject) {
      if (axios) {
        axios.get(endpoint, {
          params: params
        }).then(function (res) {
          return resolve(res.data);
        }).catch(function (err) {
          return reject(err);
        });
      } else {
        fetch(endpoint + '?' + new URLSearchParams(params)).then(function (res) {
          return res.json();
        }).then(function (data) {
          return resolve(data);
        }).catch(function (err) {
          return reject(err);
        });
      }
    }); // handle promise result

    dataPromise.then(function (data) {
      setIsLoading(false);
      setTotalPages(data.totalPages);
      setData(data.content);

      if (onResponse) {
        onResponse(data);
      }
    }).catch(function (err) {
      setIsLoading(false);
      setError(err);
    });
  }, [currentPage, search, sortBy, sortDir]);

  var getSerialNo = function getSerialNo(index) {
    return currentPage * mPageSize + (index + 1);
  };

  var getSortKey = function getSortKey(col) {
    if (col.sortable === undefined || col.sortable) {
      if (typeof col.value === 'function') {
        return col.sortKey;
      } else if (col.value !== '#') {
        return col.value;
      } else {
        return undefined;
      }
    } else {
      return undefined;
    }
  };

  var getSortClassName = function getSortClassName(col) {
    var sortKey = getSortKey(col);

    if (sortKey) {
      if (sortKey === sortBy) {
        return 'sortable ' + sortDir;
      } else {
        return 'sortable';
      }
    } else {
      return '';
    }
  };

  var onSort = function onSort(col) {
    var sortKey = getSortKey(col);

    if (sortKey) {
      if (sortBy !== sortKey) {
        setSortBy(sortKey);
      }

      setSortDir(sortDir === 'asc' ? 'desc' : 'asc');
    }
  };

  var resolve = function resolve(path, obj) {
    return path.split('.').reduce(function (prev, curr) {
      return prev ? prev[curr] : null;
    }, obj);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("table", {
    className: "table table-striped"
  }, /*#__PURE__*/_react.default.createElement("thead", null, /*#__PURE__*/_react.default.createElement("tr", null, columns.map(function (col, index) {
    return (col.display === undefined || col.display) && /*#__PURE__*/_react.default.createElement("th", {
      key: index,
      className: !disableSorting && getSortClassName(col),
      onClick: !disableSorting && function (e) {
        return onSort(col);
      }
    }, col.label);
  }), actions && /*#__PURE__*/_react.default.createElement("th", null, actionsLabel))), /*#__PURE__*/_react.default.createElement("tbody", null, isLoading && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
    colSpan: columns.length + (actions ? 1 : 0),
    className: "rru-pageable-table-loading-td"
  })), /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
    colSpan: columns.length + (actions ? 1 : 0),
    className: "rru-pageable-table-loading-td"
  }, /*#__PURE__*/_react.default.createElement("div", {
    colSpan: columns.length + (actions ? 1 : 0),
    className: "progressBar"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "indeterminate"
  }))))), data.length === 0 && /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
    colSpan: columns.length + (actions ? 1 : 0),
    className: "rru-pageable-table-centered"
  }, noDataLabel || 'No Data')), data.map(function (row, i) {
    return /*#__PURE__*/_react.default.createElement("tr", {
      key: i
    }, columns.map(function (col, j) {
      return (col.display === undefined || col.display) && /*#__PURE__*/_react.default.createElement("td", {
        key: j
      }, typeof col.value === 'function' ? col.value(row) : col.value === '#' ? getSerialNo(i) : resolve(col.value, row));
    }), actions && /*#__PURE__*/_react.default.createElement("td", null, actions.map(function (a, k) {
      return !a.display || a.display(row) ? /*#__PURE__*/_react.default.createElement(_reactRichUiButton.default, {
        key: k,
        labelId: a.labelId,
        icon: typeof a.icon === 'function' ? a.icon(row) : a.icon,
        userPrivileges: userPrivileges,
        allowedPrivileges: a.privileges,
        confirmationTitle: a.confirmationTitle,
        confirmationDesc: a.confirmationDesc,
        cancelLabel: a.cancelLabel,
        confirmLabel: a.confirmLabel,
        onConfirm: a.onConfirm ? function () {
          return a.onConfirm(row);
        } : undefined,
        onClick: function onClick() {
          return a.action(row);
        }
      }) : null;
    })));
  }))), /*#__PURE__*/_react.default.createElement(_reactPaginate.default, {
    previousLabel: previousLabel,
    nextLabel: nextLabel,
    breakLabel: /*#__PURE__*/_react.default.createElement("a", null, "..."),
    breakClassName: "break",
    pageCount: totalPages,
    marginPagesDisplayed: 2,
    pageRangeDisplayed: 3,
    onPageChange: function onPageChange(event) {
      return setCurrentPage(event.selected);
    },
    forcePage: currentPage,
    containerClassName: "pagination",
    pageLinkClassName: "pageLink",
    previousClassName: "previous",
    nextClassName: "next",
    disabledClassName: "disabled",
    activeClassName: "activePage"
  }));
};

var _default = RruPageableTable;
exports.default = _default;